

class asteroid{

private:
	// the asteroid 's centre coordinates.
	// translate asteroid by these values.
	float deltaX;
	float deltaY;

	// scale the asteroid using these members.	
	float scaleX;
	float scaleY;

	// the red, green and blue components of the asteroid's color
	float R,G,B;

	// a counter to keep track of the number of vertices.
	int ctr;

	// the vertices of the asteroid.Maximum vertices is 500.
	float vertices[1000];
	
	// the angle of rotation of the asteroid.
	float angle;

	// the radius of the asteroid.
	float radius;
	
	// flas to direct the motion of the asteroid.
	int goUp,goDown,goLeft,goRight;	
	
	// direction in which asteroid turns
	// +1 for clockwise 
	// -1 for counterclockwise.
	int turnDir;	

	// flag to keep track of whether asteroid was hit.
	int hit_by_missile;

	// status of asteroid - alive or destroyed.
	int killed;

public:
	// constructor
	asteroid();

	// read the input file containing asteroid coordinates.
	int readInput(const char* filename);

	// draw the asteroid.
	void draw();

	// draws an explosion.
	void drawExplosion();

	// color the asteroid.
	void setColor(float red, float green, float blue);

	// sets the scaling factor of the asteroid.
	void scale(float value);

	// returns the direction in which asteroid turns (-1 or 1).
	int getTurnDir();

	// set the direction in which the asteroid will turn.
	void setTurnDir(int value);

	// returns the angle of rotation of the asteroid.
	float getAngle();

	// returns the x coordinate of the centre of the asteroid.
	float getdeltaX();

	//  returns the y coordinate of the centre of the asteroid.
	float getdeltaY();

	// initialises the asteroid centre to origin.
	void resetDeltaXY();

	// returns the scale factor in the x direction.
	float getScaleX();

	// returns the scale factor in the y direction.
	float getScaleY();

	// set deltaX.
	void SetDeltaX(float X);
	
	// set deltaY.
	void SetDeltaY(float Y);
	
	// perform some initializations.
	void setFirstTime();

	// returns the radius of the asteroid.
	float getRadius();

	// sets the hitByMissile flag to indicate that asteroid has been shot.
	void setHitByMissile();

	// resets the hitByMissile flag.
	void resetHitByMissile();
	
	// returns whether asteroid was hit or not.
	int getHitByMissile();

	// set the killed flag to indicate that asteroid is destroyed.
	void setKilled();	

	// reset the killed flag to indicate that asteroid is now active again.
	void resetKilled();	

	// returns the status of the asteroid - whether it is killed or not.
	int getKilled();
	
	// move the asteroid in the x direction.
	void moveX(float X);

	// move the asteroid in the y direction.	
	void moveY(float Y);

	// rotate the asteroid in the direction specified by the sign on delta.
	void Turn(float delta);
	
	// calculate the radius of the asteroid.
	float CalculateRadius();

		
};
