
class ship{

private:
	// the ship's centre position.
	float deltaX,deltaY;
	
	// ship's scale factor.
	float scaleX, scaleY;
	
	// the thrust component's in x and y .
	float thrustX, thrustY;

	// color components. 
	float R,G,B;

	// no of variables.
	int ctr;
	
	// angle of rotation.
	float angle;
	
	// the vertices of the ship.
	float vertices[1000];

	// radius of the ship.
	float radius;

	// flag to indicate that ship has appeared for the first time
	int firstTime;

	// direction of turning.
	int turnDir;	

	// whether an asteroid hit the ship.
	int hit_by_asteroid;

	// whether the ship was destroyed.
	int killed;

public:

	// reads the coordinates of the ship from the inout file.
	int readInput(const char* filename);
	
	// draw the ship
	void draw();
	
	// draw an explosion.
	void drawExplosion();

	// set the color of the ship.
	void setColor(float red, float green, float blue);

	// set the scale factor of the ship.
	void scale(float value);

	// returns the angle of rotation.
	float getAngle();
	
	// reset the angle for the starting position.
	void resetAngle();

	// returns deltaX.
	float getDeltaX();

	// returns deltaY.
	float getDeltaY();

	// initializes the ship's centre to the origin.
	void resetDeltaXY();

	// initialize the x coordinate of the ship's centre.
	void SetDeltaX(float X);
	
	// initialize the y coordinate of the ship's centre.
	void SetDeltaY(float Y);
	
	// performs initialization.
	void setFirstTime();

	// reset the firstTime flag.
	void resetFirstTime();

	// get the status of the firstTime flag.
	int getFirstTime();
	
	// sets the hitByAsteroid flag.
	void setHitByAsteroid();

	// sets the hitByAsteroid flag.
	void resetHitByAsteroid();

	// returns the status of the ship - whether it was hit or not.	
	int getHitByAsteroid();

	void setKilled();	

	void resetKilled();

	int getKilled();

	// moves the ship in the x direction.	
	void moveShipX(float X);

	// moves the ship in the y direction.	
	void moveShipY(float Y);

	// rotates the ship by the specified angle.
	void Turn(float delta);

	// accelerate the ship.	
	void Thrust(float maxSpeed);

	// returns the thrust of the ship in the x direction.
	float getThrustX();

	// returns the thrust of the ship in the y direction.
	float getThrustY();

	// initialize the thrust to 0 for starting position of the ship.
	void resetThrust();

	// calculate the collision radisu of the ship.
	float CalculateRadius();

	// return the radius of the spaceship.
	float getRadius();

//draw radi is not needed
	void DrawRadius(); 

};				

		
