
#include "textdisplay.hxx"
#include <stdio.h>
#include <glut.h>

// set the Color of display.
void textdisplay::setColor(float red, float green, float blue)
{
	R = red;
	G = green;
	B = blue;
}

// print a string on the screen at the specified position.
void textdisplay::drawText(char *buffer,float x,float y)
{
         char *p;
	 glColor3f(R,G,B);
	 glPushMatrix();
		glTranslatef(x, y, 0);
		glRotatef(180.0,1.0,0.0,0.0);
                glScalef(0.1, 0.1, 0.0);
	        for (p = buffer; *p; p++)
               	     glutStrokeCharacter(GLUT_STROKE_ROMAN, *p);
         glPopMatrix();


}

// print a number on the screen.
void textdisplay::drawValue(int buffer,float x,float y)
{
	 char *p;
         char value[80];
	 sprintf(value,"%i", buffer); // convert it to a string first.
	 glColor3f(R, G, B);
	 glPushMatrix();
		glTranslatef(x, y, 0);
		glRotatef(180.0,1.0,0.0,0.0);
                glScalef(0.1, 0.1, 0.0);
	        for (p = value; *p; p++)
         	     glutStrokeCharacter(GLUT_STROKE_ROMAN, *p);
         glPopMatrix();


}

// increase the no of ships.
void textdisplay::increaseShipCtr()
{
	shipCtr++;
}

// increase the number of asteroids.		
void textdisplay::increaseAsteroidCtr()
{
	asteroidCtr++;
}

// return the no of ships.			
int textdisplay::getShipCtr()
{
	return shipCtr;
}

// return teh no of asteroids.
int textdisplay::getAsteroidCtr()
{
	return asteroidCtr;
}
